<?php

namespace App\Controllers\Auth;

use App\Controllers\CommonController;

use App\Entities\UserEntity;
use App\Helpers\AuthHelper;
use App\Libraries\LogCollector;
use CodeIgniter\HTTP\RedirectResponse;

use CodeIgniter\HTTP\RequestInterface;
use CodeIgniter\HTTP\ResponseInterface;
use Psr\Log\LoggerInterface;

abstract class AuthController extends CommonController
{
    private $_helper = null;
    public function initController(RequestInterface $request, ResponseInterface $response, LoggerInterface $logger)
    {
        parent::initController($request, $response, $logger);
        $this->layout = "auth";
        $this->uri_path = "auth/";
        $this->view_path = "auth" . DIRECTORY_SEPARATOR;
        $this->title     = "사용자인증";
        $this->individualStylesheets = [];
        $this->individualScripts = [];
    }
    abstract protected function getSNSButton(): string;
    final public function getHelper(): mixed
    {
        if (!$this->_helper) {
            $this->_helper = new AuthHelper($this->request);
        }
        return $this->_helper;
    }

    //로그인 실패시 오류에서는 Logger에 남기지 않아야 함.
    protected function getResultFail(string $message = MESSAGES["FAILED"]): RedirectResponse|string
    {
        if (env('app.debug.' . $this->getAction())) {
            $result = $message;
        } else {
            $result = redirect()->back()->withInput()->with('error', $message);
        }
        return $result;
    }

    //로그인화면
    public function create_form_process(): void
    {
        $this->sns_buttoh = $this->getSNSButton();
    }
    //로그아웃
    final public function logout(): RedirectResponse
    {
        try {
            $this->getService()->logout();
            // 홈페이지로 리다이렉트
            return redirect()->route('/')->with('error', MESSAGES['LOGOUT']);
        } catch (\Exception $e) {
            log_message("error", $e->getMessage());
            return redirect()->back()->with('error', "로그아웃 중 오류가 발생했습니다.");
        }
    }
}
